#!/usr/bin/perl

=begin comment info
 +-----------------------------------------------------------------------------+
 | Copyright 2001-2003, Guardian Digital Inc.
 | $Id: do_send_sysoverview.cgi,v 1.1.2.6 2003/04/22 08:22:53 rwm Exp $
 |
 | Ryan W. Maple <ryan@guardiandigital.com>
 +-----------------------------------------------------------------------------+
=end comment info
=cut

  BEGIN { push @INC, '/usr/webtool/modules'; }

  # use perl;
  use Net::SSLeay qw(post_https make_form); 
  use Sys::Hostname;
  use WebTool;
  use vars qw($output);
  sub make_sysoverview();
  sub send_sysoverview();

  my %in = WebTool::parseFormData();

  if ($in{'send'}) {
    make_sysoverview();

    my $msg = 'Thank you very much for sending this overview.';
    if (send_sysoverview() != 0) {
      $msg = "An error occured while trying to send this overview.\\n"
           . "Please confirm your GDSN machine settings and try again.";
    }
    WebTool::PrintError($msg);
  }
  else { WebTool::Redirect('index.cgi'); }

################################################################################
sub send_sysoverview() {
  my $activation_code      = $modconfig{'activation_code'};
  my $password             = $modconfig{'password'};
  my $secret               = &fingerprint();
  my $UPDATES_HOST         =  'updates.guardiandigital.com';
  my $PAYLOAD_QUERY_STRING =  '/cgi-bin/gdsn_proxy.cgi';
  my $HOSTNAME             = hostname();
  my $DISTRO_STRING        = 'feint';

  my ($page) = post_https("$UPDATES_HOST", 443, "/$PAYLOAD_QUERY_STRING", '',
                          make_form('activation_code'  => "$activation_code",
                                    'password'         => "$password",
                                    'secret'           => "$secret",
                                    'distro'           => "$DISTRO_STRING",
                                    'hostname'         => "$HOSTNAME",
                                    'package'          => "$_[3]",
                                    'fcn'              => "sysoverview",
                                    'overview'         => "$output"));

  return (! $page || $page =~ m/^ERROR\:\ ([0-9]+)$/) ? -1 : 0;
}

################################################################################
sub make_sysoverview() {
  $output = '';
  header();

  # Read files.
  foreach my $get ('/proc/cpuinfo', '/proc/interrupts', '/proc/meminfo',
                   '/proc/pci', '/proc/swaps', '/proc/version', '/proc/modules',
                   '/var/log/dmesg', '/proc/bus/pci/devices')
  {
    my $got  = read_file($get);
    my $show = "Output of '$get'";

    $output .= "$show\n";
    foreach (split //, $show) { $output .= '-'; }
    $output .= "\n$got\n";
  }

  # Run commands.
  foreach my $cmd ('rpm -qa --last', 'df -hPT') {
    my $got  = run_cmd($cmd);
    my $show = "Output of '$cmd'";

    $output .= "$show\n";
    foreach (split //, $show) { $output .= '-'; }
    $output .= "\n$got\n";
  }
}

################################################################################
sub header() {
  # Get our hostname and EnGarde version.
  open H, '/etc/hostname'; my $H = <H>; chomp $H; close H;
  open R, '/etc/engarde-release'; my $R = <R>; chomp $R; close R;

  # Ereet header.
  $output .= sprintf("%s%s%s", '+', '-'x72, "+\n");
  $output .= sprintf("| %-70.70s |\n", $H);
  $output .= sprintf("| %-70.70s |\n", $R);
  $output .= sprintf("%s%s%s", '+', '-'x72, "+\n\n");
}

################################################################################
sub read_file($) {
  my $file = shift;
  my $rv   = '';

  open FILE, $file; while (<FILE>) { $rv .= $_; } close FILE;

  return $rv;
}

################################################################################
sub run_cmd($) {
  my $cmd = shift;
  my $rv  = '';

  WebTool::output_ctl(0);
    open CMD, "$cmd |"; while (<CMD>) { $rv .= $_; } close CMD;
  WebTool::output_ctl(1);

  return $rv;
}

###############################################################################
sub fingerprint() {
  my $KEYGEN           = '/usr/bin/ssh-keygen';
  my $SSH_HOST_KEY_PUB = '/etc/ssh/ssh_host_key.pub';
  my $file             = shift;

  open KEYGEN, "$KEYGEN -l -f $SSH_HOST_KEY_PUB |";
    my ($fprint) = (<KEYGEN> =~ m/^[0-9]+\ ([A-Za-z0-9\:]+)\ /);
  close KEYGEN;

  return $fprint;
}
