#!/usr/bin/perl

=begin comment info
 +-----------------------------------------------------------------------------+
 | Copyright 2001-2002, Guardian Digital Inc.
 | $Id: installation_check.cgi,v 1.1.4.2 2003/04/22 20:52:42 rwm Exp $
 |
 | Ryan W. Maple, <ryan@guardiandigital.com>
 +-----------------------------------------------------------------------------+
=end comment info
=cut

  ###  Import our local jPM database and library subroutines.
  use RPM::Database '%RPM';
  require "GDSN-lib.pl";


  ###  Define local variables.
  my ($activation_code, $password, $secret, $cnt_p, $cnt_d, %PAYLOAD);

  ###  Setup local variables.
  $activation_code = $config{'activation_code'};
  $password        = $config{'password'};
  $secret          = &fingerprint($SSH_HOST_KEY_PUB);
  $cnt_p           = 0;
  $cnt_d           = 0;
  $rc              = &GDSN_Get_Payload($activation_code, $password, $secret);

  # ACTIVATION_CODE_EXPIRED => 0x0003.
  &read_file("$module_config_directory/config", \%tmp);
    $tmp{'activation_code_expired'} = ($rc == 3) ? 1 : 0;
  &write_file("$module_config_directory/config", \%tmp);

  ###  Print header.
  &header("Guardian Digital Secure Network :: Installation Package List", 0);

  ###  Print some HTML.
  print <<EOF;
<FORM ACTION="installation_download.cgi" METHOD="POST">
<P><CENTER><TABLE BORDER="0" WIDTH="620" CELLPADDING="0" CELLSPACING="0">
  <TR $tb>
    <TD COLSPAN="2"><DIV CLASS="ttitle"><B>Guardian Digital Secure Network</B></DIV></TD>
  </TR>

  <TR $cb>
    <TD COLSPAN="2"><DIV CLASS="nbody">
      Below is a listing of candidate packages for installation.  Please select
      the ones you wish to install and click the "Install Packages" button.
    </DIV></TD>
  </TR>

  <TR $cb> <TD COLSPAN="2"> &nbsp; </TD> </TR>

  <TR $cb>
    <TD WIDTH="10"> &nbsp; </TD>
    <TD $cb>
    <TABLE BORDER="0" WIDTH="100%" CELLSPACING="0" CELLPADDING="0">
EOF

  ###  Try to read our payload file and set error code if it's invalid.
  do "$INCOMING_DIR/Payload.pl";
  if (! $rc && (! defined &gdupdate_populate)) { $rc = -3; }


  ###  We successfully retrieved the Payload.
  if ($rc == 0) {
    %PAYLOAD = &gdupdate_populate();

    # We've gotten this far so assume it's activated.
    &read_file("$module_config_directory/config", \%tmp);
      $tmp{'activated'} = 1;
    &write_file("$module_config_directory/config", \%tmp);

    ###
    ###  Iterate over the packages in the payload, only printing the 
    ###  record if it it has ->{'INSTALLABLE'} set.
    ###  (bewm)
    ###
    foreach my $k (sort keys %PAYLOAD) {
      $cnt_p++;

      if (! $RPM{$k} && $PAYLOAD{$k}->{'INSTALLABLE'}) {
        $cnt_d++;

        print <<EOF;
    <TR $tb>
      <TD COLSPAN="3"><DIV CLASS="thead">
        <B>$k</B>:  $PAYLOAD{$k}{'SUMMARY'}
      </DIV></TD>
    </TR>

    <TR $cb>
      <TD><DIV CLASS="nbody"><B>Severity</B>:</DIV></TD>
      <TD WIDTH="80%" COLSPAN="2"><DIV CLASS="nbody">
        $SEVERITY_MAP{$PAYLOAD{$k}->{'SEVERITY'}}
      </DIV></TD>
    </TR>

    <TR $cb>
      <TD><DIV CLASS="nbody">
        <B>Advisory</B>:
      </DIV></TD>
      <TD WIDTH="80%" COLSPAN="2"><DIV CLASS="nbody">
        $adv_link
          <A onClick='window.open("https://$UPDATES_HOST/$PAYLOAD{$k}->{'ADVISORY'}", "help", "toolbar=no,menubar=no,scrollbars=yes,width=400,height=150,resizable=yes"); return false' href="https://$UPDATES_HOST/$PAYLOAD{$k}->{'ADVISORY'}">$PAYLOAD{$k}->{'ADVISORY'}</A>
      </DIV></TD>
    </TR>

    <TR $cb>
      <TD><DIV CLASS="nbody"><B>Available&nbsp;Version:</B></DIV></TD>
      <TD WIDTH="80%" COLSPAN="2"><DIV CLASS="nbody">
        $PAYLOAD{$k}->{'VERSION'} ($PAYLOAD{$k}->{'RELEASE'})
      </DIV></TD>
    </TR>

EOF

      ###  Print our dependancy information if we are told to.
      my ($i, $tmp_cnt, $dep_status, $DEPS_STR);

      $DEPS_STR   =  undef;
      $tmp_cnt    =  0;
      $dep_status =  "<FONT COLOR=\"RED\">Unresolved</FONT>";

      for ($i = 0; $PAYLOAD{$k}->{'REQUIRES'}[$i]; $i++) {
        $tmp_cnt++ if ($RPM{$PAYLOAD{$k}->{'REQUIRES'}[$i]}{'SUMMARY'});

        if ($config{'advanced_view'}) {
          $DEPS_STR .= "    <TR $cb>\n";
          $DEPS_STR .= "      <TD> &nbsp; </TD>\n";
          $DEPS_STR .= "      <TD WIDTH=\"20%\" VALIGN=\"TOP\"><DIV CLASS=\"nbody\">$PAYLOAD{$k}->{'REQUIRES'}[$i]</DIV></TD>\n";
          $DEPS_STR .= "      <TD WIDTH=\"60%\"><DIV CLASS=\"nbody\">\n";
          $DEPS_STR .= "        $RPM{$PAYLOAD{$k}->{'REQUIRES'}[$i]}{'SUMMARY'}\n";
          $DEPS_STR .= "      </DIV></TD>\n";
          $DEPS_STR .= "    </TR>\n\n";

        }
      }

      $dep_status = "<FONT COLOR=\"GREEN\">Resolved</FONT>" if ($i == $tmp_cnt);

      ###  More HTML.
      print <<EOF;

    <TR $cb>
      <TD><DIV CLASS="nbody">
        <B>Dependancies</B>:
      </DIV></TD>
      <TD WIDTH="20%"><DIV CLASS="nbody">
        <B>$dep_status</B>
      </DIV></TD>
      <TD ALIGN="RIGHT" NOWRAP WIDTH="60%"><DIV CLASS="nbody">
EOF


      ###
      ###  (XXX)  Only let the user install if the deps are satisfied.
      ###
      if ($i == $tmp_cnt) {
        print "        <B>Install:</B> <INPUT TYPE=\"CHECKBOX\" NAME=\"$k\"";
        print " CHECKED" if ($config{'autocheck'});
        print ">\n";
      }
      else {
        print "        &nbsp;\n";
      }


      ###  More HTML.
      print <<EOF;
      </DIV></TD>
    </TR>

$DEPS_STR

    <TR $cb> <TD COLSPAN="3"> &nbsp </TD> </TR>

EOF
      }
    }

    ###  Print the "Install Packages" button.
    if ($cnt_d != 0) {
      print <<EOF;
    <TR $cb>
      <TD COLSPAN="3" ALIGN="RIGHT"> <DIV CLASS="nbody">
          <INPUT TYPE="SUBMIT" NAME="get" VALUE="Install Packages">
      </DIV> </TD>
    </TR>

EOF
    }
  }

  ###
  ###  No packages or an error.  Bitch.
  ###  (bewm)
  ###
  else {

    ###  Bump this here so we dont' trigger the case directly below.
    $cnt_d++;

    print <<EOF;
  <TR $cb>
    <TD WIDTH="10"> &nbsp; </TD>
    <TD>
      <DIV CLASS="nbody">
        An error occured while trying to run the Guardian Digital Secure Update
        Agent.  It is possible that the server is down or unreachable.  The
        error is as follows:

        <P><B>Error Code</B>:  $rc<BR>
        <B>Error</B>: $CONNECTION_ERRORS{$rc}<BR>

        <P>Please try again at a later time.
      </DIV>
    </TD>
  </TR>

  <TR $cb><TD COLSPAN="2">&nbsp;</TD></TR>

EOF
  }


  ###
  ###  No packages are available for updating.
  ###  (bewm)
  ###
  if (! $cnt_d) {
    print <<EOF;
  <TR $cb>
    <TD WIDTH="10"> &nbsp; </TD>
    <TD>
      <DIV CLASS="nbody"><B>
        Your packages are all up to date.

        <P><A HREF="index.cgi">[ Return to Main GDSN Page ]</A>
      </B></DIV>
    </TD>
  </TR>

  <TR $cb><TD COLSPAN="2">&nbsp;</TD></TR>
  
EOF
  }


  ###  Print some HTML.
  print <<EOF;
    </TABLE>
    </TD>
  </TR>
</TABLE></CENTER><P></FORM>
EOF


  ###  Print footer.
  &ryanFooter("index.cgi");

