#!/usr/bin/perl

=begin comment info
 +-----------------------------------------------------------------------------+
 | Copyright 2001-2002, Guardian Digital Inc.
 | $Id: installation_download.cgi,v 1.1 2002/02/18 14:27:38 rwm Exp $
 |
 | Ryan W. Maple, <ryan@guardiandigital.com>
 +-----------------------------------------------------------------------------+
=end comment info
=cut

  ###  Import our library subroutines and populate %in.
  require "GDSN-lib.pl";
  &ReadParse();


  ###  Define local variables.
  my ($activation_code, $password, $secret);
  my (%PAYLOAD, $PAYLOAD_CNT, %PACKAGES, $cmd, $redirect_str);

  ###  Setup local variables.
  $PAYLOAD_CNT     = 0;
  $activation_code = $config{'activation_code'};
  $password        = $config{'password'};
  $secret          = &fingerprint($SSH_HOST_KEY_PUB);
  $redirect_str    = undef;
  $cmd             = "rpm -U --excludedocs ";


  ###  Reload our payload and iterate over it, retrieveing packages as needed.
  do "$INCOMING_DIR/Payload.pl";
  %PAYLOAD = &gdupdate_populate();

  foreach my $k (sort keys %PAYLOAD) {
    my ($rv);

    ###  Skip over packages we did not choose to upgrade.
    next if (! $in{$k});

    ###  Bump our counter and get the package.
    $PAYLOAD_CNT++;
    $rv = &GDSN_Get_Package($activation_code, $password, $secret, $PAYLOAD{$k}->{'PACKAGE'});

    ###
    ###  Case 1:  We got an error.  Display the standard error screen.
    ###
    if (($rv < 0) || ($rv > 0)) {
      &header("Guardian Digital Secure Network :: Package List", 0);

      print <<EOF;
<FORM ACTION="installation_download.cgi" METHOD="POST">
<P><CENTER><TABLE BORDER="0" WIDTH="620" CELLPADDING="0" CELLSPACING="0">
  <TR $tb>
    <TD COLSPAN="2"><DIV CLASS="ttitle"><B>Guardian Digital Secure Network</B></DIV></TD>
  </TR>

  <TR $cb> <TD COLSPAN="2"> &nbsp; </TD> </TR>

  <TR $cb>
    <TD WIDTH="10"> &nbsp; </TD>
    <TD $cb>
    <TABLE BORDER="0" WIDTH="100%" CELLSPACING="0" CELLPADDING="0">
    <TR $cb>
      <TD WIDTH="10"> &nbsp; </TD>
      <TD>
        <DIV CLASS="nbody">
          An error occured while trying to retrieve the package <B>$PAYLOAD{$k}->{'PACKAGE'}</B>:

          <P><B>Error Code</B>:  $rv<BR>
          <B>Error</B>: $CONNECTION_ERRORS{$rv}<BR>

          <P>Please try again at a later time.
        </DIV>
      </TD>
    </TR>

    <TR $cb><TD COLSPAN="2">&nbsp;</TD></TR>
    </TABLE>
    </TD>
  </TR>
</TABLE></CENTER><P></FORM>
EOF

      &ryanFooter("installation_check.cgi");
      exit;
    }


    ###
    ###  Case 2:  It returned a filename.  Push onto array and move on.
    ###
    else { $PACKAGES{$k} = $rv; }
  }


  ###
  ###  The user didn't select any packages to install.  Kindly tell them.
  ###
  if (! $PAYLOAD_CNT) {
    &PrintError("Please select at least one package to install.");
    exit;
  }


  ###
  ###  We now have all our candidate packages.  Build our command string.
  ###    - Only install the package if the signature/md5 is correct.
  ###
  foreach my $p (sort keys %PACKAGES) {
    if (! &SignatureIsValid("$INCOMING_DIR/$PACKAGES{$p}")) {
      &PrintError("One or more packages had an invalid signature.  Refusing to install.");
      exit;
    }

    $cmd .= "$INCOMING_DIR/$PACKAGES{$p} ";
    $redirect_str .= "$p=1&";
  }
  $cmd .= "> /dev/null 2>&1";


  ###  Install our updated packages, trying our test to detect dependancy
  ###  problems. (XXX AUD)
  my ($RC); $RC = system($cmd);

  if ($RC != 0) {
    &PrintError("The packages could not be installed because there were unresolved dependancies.");
    exit;
  }


  ###  Re-init the LIDS configuration.
  &lids_toggle('off');
  system("$LIDS_CONFIG_SCRIPT --force > /dev/null 2>&1");
  &lids_toggle('on');


  ###  Remove local packages.
  foreach my $p (sort keys %PACKAGES) { unlink "$INCOMING_DIR/$PACKAGES{$p}"; }

  ###  All done.  Strip off trailing '&' and display status.
  $redirect_str =~ s/\&$//;
  &redirect("installation_summary.cgi?$redirect_str");

